#include <stdio.h>
#include <stdlib.h>

void ispis(int *a, int n)
{
	int i;
	for(i = 0; i < n; i++)
		printf("%3d", a[i]);
	printf("\n");
}

void permutacija(int *a, int i, int n)
{
	if(i == n)
		ispis(a, n);
	else
	{
		//elementi 0, 1, 2,..., i-1 su fiksirani
		//na i-to mesto moze da dodje bilo koji broj
		//na pozicijama i, i+1,...,n-1
		int j;
		for(j = i; j < n; j++)
		{
			//j-ti stavimo na i-to mesto
			//i pozemo rekurziju za ostatak
			
			//okrecemo i-ti i j-ti
			int t = a[i];
			a[i] = a[j];
			a[j] = t;
			
			//rekurzija
			permutacija(a, i + 1, n);
			
			//vracamo i-ti i j-ti
			t = a[i];
			a[i] = a[j];
			a[j] = t;
		}
	}
}

int main()
{
	int n;
	scanf("%d", &n);
	
	int *a = malloc(n * sizeof(int));
	if(a == NULL)
	{
		printf("greska");
		return;
	}
	
	//inicijalno popunjavamo permutaciju
	//1 2 3 4 ... n
	int i;
	for(i = 1; i <= n; i++)
		a[i - 1] = i;
	
	permutacija(a, 0, n);
	
	free(a);
}