#include <stdio.h>
#include <stdlib.h>

void stampaj(int *a, int n)
{
	int i;
	for(i = 0; i < n; i++)
		printf("%d ", a[i]);
	printf("\n");
}

//nadji rastuci podniz niza a, 
//smesti ga u b
//gledaj od i-tog el iz a
//dodaj u j-ti element u b
//a je duzine n
void rastuci_podniz(int *a, int *b, int ia, int ib, int n)
{
	if(ia == n)
	{
		stampaj(b, ib);
	}
	else
	{
		//imamo dva slucaja
		//element ia u nizu a
		//1. preskacemo
		//2. uzimamo u obzir
		
		//1. preskacemo
		rastuci_podniz(a, b, ia + 1, ib, n);
		
		//2. uzimamo u obzir
		if(ib == 0)
		{
			//jos uvek nista nismo dodali u niz b
			//znaci sigurno mozemo da dodamo element
			b[ib] = a[ia];
			rastuci_podniz(a, b, ia + 1, ib + 1, n);
		}
		else
		{
			if(a[ia] > b[ib - 1])
			{
				b[ib] = a[ia];
				rastuci_podniz(a, b, ia + 1, ib + 1, n);
			}
		}
	}
}

int main()
{
	int n;
	scanf("%d", &n);
	int *a = malloc(n * sizeof(int));
	
	//PROVERA MALLOC
	
	int i;
	for(i = 0; i < n; i++)
		scanf("%d", &a[i]);
	
	//niz u koji pakujemo rez.
	int *b = malloc(n * sizeof(int));
	//PROVERA
	
	rastuci_podniz(a, b, 0, 0, n);
	
	free(a);
	free(b);
}