#include <stdio.h>
#include <stdlib.h>

void greska(char *s)
{
	fprintf(stderr, "Greska: %s\n", s);
	//fprintf(stdout, "Greska: %s\n", s); <-> printf(...
	
	exit(EXIT_FAILURE);
}

void ispis(int *a, int n)
{
	int i;
	for(i = 0; i < n; i++)
		printf("%d", a[i]);
	printf("\n");
}

//a - niz u koji upisujemo varijaciju
//i - broj dokle smo stigli sa upisivanje
//n - duzina niza koji se ispisuje
void var_sa_ponavljanjem(int *a, int i, int n)
{
	if(i == n)
	{
		//popunili smo niz a do kraja sa odgovarajucom
		//varijacijom, i treba da ga ispisemo na st. izlaz
		ispis(a, n);
	}
	else
	{
		//nismo popunili niz a do kraja,
		//treba da popunimo i-to mesto i rekurzivno
		//da nastavimo dalje
		a[i] = 0;
		var_sa_ponavljanjem(a, i + 1, n);
		a[i] = 1;
		var_sa_ponavljanjem(a, i + 1, n);
		a[i] = 2;
		var_sa_ponavljanjem(a, i + 1, n);
	}
}

int main()
{
	int *a;
	int n;
	scanf("%d", &n);
	a = malloc(n * sizeof(int));
	if(a == NULL)
		greska("malloc");
		
	var_sa_ponavljanjem(a, 0, n);
		
	free(a);
}