#include <stdio.h>
#include <stdlib.h>

void greska(char *s)
{
	fprintf(stderr, "Greska: %s\n", s);
	exit(EXIT_FAILURE);
}

void ispis(int *a, int n)
{
	int i;
	for(i = 0; i < n; i++)
		printf("%d", a[i]);
	printf("\n");
}

void permutacija(int *a, int i, int n)
{
	if(i == n)
		ispis(a, n);
	else
	{
		int j;
		for(j = i; j < n; j++)
		{
			//zamena i-tog i j-tog
			//rek. poziv
			//zamena i-tog i j-tog - vracanje na staro stanje
			
			int t = a[i];
			a[i] = a[j];
			a[j] = t;
			
			permutacija(a, i+1, n);
			
			t = a[i];
			a[i] = a[j];
			a[j] = t;
		}
	}
}

int main()
{
	int *a;
	int n;
	scanf("%d", &n);
	a = malloc(n * sizeof(int));
	if(a == NULL)
		greska("malloc");
	
	//pravimo inicijalnu permutaciju
	int i;
	for(i = 0; i < n; i++)
		a[i] = i + 1;
		
	permutacija(a, 0, n);
		
	free(a);
}