#include <stdio.h>
#include <stdlib.h>

void greska(char *s)
{
	fprintf(stderr, "Greska: %s\n", s);
	exit(EXIT_FAILURE);
}

void ispis(int *a, int n)
{
	int i;
	for(i = 0; i < n; i++)
		printf("%d", a[i]);
	printf("\n");
}

void brojevi(int *a, int i, int n, 
	int p, int q, int r)
{
	//uslov zaustavljanja
	//vise ne mozemo da upisujemo ni 1, ni 2, ni 3
	if(p == 0 && q == 0 && r == 0)
	{
		ispis(a, n);
	}
	else
	{
		if(p > 0)
		{
			a[i] = 1;
			brojevi(a, i+1, n, p-1, q, r);
		}
		if(q > 0)
		{
			a[i] = 2;
			brojevi(a, i+1, n, p, q-1, r);
		}
		if(r > 0)
		{
			a[i] = 3;
			brojevi(a, i+1, n, p, q, r-1);
		}
	}
}

int main()
{
	int *a;
	int n;
	int p, q, r;
	scanf("%d%d%d", &p, &q, &r);
	n = p + q + r;
	a = malloc(n * sizeof(int));
	if(a == NULL)
		greska("malloc");

//void brojevi(int *a, int i, int n, 
//	int p, int q, int r)		
	brojevi(a, 0, n, p, q, r);
		
	free(a);
}