#include <stdio.h>
#include <stdlib.h>

void greska(char *s)
{
	fprintf(stderr, "Greska: %s\n", s);
	exit(EXIT_FAILURE);
}

void ispis(int *a, int n)
{
	int i;
	for(i = 0; i < n; i++)
		printf("%d ", a[i]);
	printf("\n");
}

void rastuci_podniz(int *a, int *b, int ia, int ib, int na)
{
	if(ia == na)
		ispis(b, ib);
	else
	{
		if(ib == 0 || b[ib-1] <= a[ia])
		{
			//1. upisujemo el. iz a
			b[ib] = a[ia];
			rastuci_podniz(a, b, ia + 1, ib + 1, na);
		}
		
		//2. ne upisejmo el. iz a
		rastuci_podniz(a, b, ia + 1, ib, na);
	}
}

int main()
{
	int n;
	int *a; //izvorni niz brojeva
	int *b; //pakuhjemo rastuci podniz
	scanf("%d", &n);
	a = malloc(n * sizeof(int));
	b = malloc(n * sizeof(int));
	//DOMACI PROVERA;
	int i;
	for(i = 0; i < n; i++)
		scanf("%d", &a[i]);
	
	rastuci_podniz(a, b, 0, 0, n);
	
	free(a);
	free(b);
}